WsLogger = { }
local WsLogger_mt= Class(WsLogger)
WsLogger.Severity = {
    Call=1,
    Debug=2,
    Verbose=3,
    Info=4,
    Warning=5,
    Error=6

}
function WsLogger:new(modName,severity)
    local self=setmetatable({}, WsLogger_mt)
    self.modName=modName or "Unknown Mod"
    self.severity=severity
    return self
end
function WsLogger:information()
    if self==nil then
        printCallstack()
        printError("Error: self is nil")
        return ""
    end
    local ret="ModName:"..self.modName.."\nSeverity:"..self.severity
    return ret;
end
function WsLogger:print(text,severity)
    local call_ok=true
    local modName="Unknown Mod!!!"
    if self.modName~=nil then
        modName=self.modName
    end
    if severity==nil then
        printCallstack()
        printError("Error: "..modName..":call wslogger::print with null severity")
        call_ok=false
    end
    if self.severity==nil then
        printCallstack()
        printError("Error: "..modName..":call wslogger::print with nil self.severity")
        call_ok=false
    end
    if call_ok==true then
        if severity>=self.severity then
            if severity==WsLogger.Severity.Warning then
                local LogText="Warning: "..modName..":"..text
                printWarning(LogText)
            elseif severity==WsLogger.Severity.Error then
                local LogText="Error: "..modName..":"..text
                printError(LogText)
            else
                local LogText=modName..":"..text
                print(LogText)
            end
        end
    end
end
function WsLogger:printVariable(variable,text,severity,depthlimit)
    if severity>=self.severity then
        local variabletext=self:prepareVariable(variable,0,depthlimit)
        local ltext=text..variabletext
        self:print(ltext,severity)
    end
end
function WsLogger:prepareVariable(variable, currentDepth,depthlimit)
    local text=""
    local depthlimit=depthlimit or 1
    if type(variable) == "string" then
        text = variable
    elseif type(variable) == "number" then
        text = tostring(variable)
    elseif type(variable) == "boolean" then
        text = tostring(variable)
    elseif type(variable) == "table" then
        text = "\n{"
        for k, v in pairs(variable) do
            local keyStr=tostring(k)
            local valueStr=""
            if currentDepth< depthlimit then
                valueStr=self:prepareVariable(v,currentDepth+1,depthlimit)
            else
                valueStr="Depth Limit reached"
            end
            text=text.."\n [" .. keyStr .."]="..valueStr..", "
        end
        text=text.."\n}"
    else
        text = "Unsupported variable type: " .. tostring(type(variable))
    end

    return text

end
