local debug=false
local modDirectory=g_currentModDirectory or ""
local modName=g_currentModName or "RealTimeSync"
local worker
local wsLogger
source(g_currentModDirectory .. 'scripts/common/WsLogger.lua')
source(g_currentModDirectory .. 'scripts/RealTimeWorker.lua')
source(g_currentModDirectory..'scripts/RealTimeEvent.lua')
local function load(mission)
    wsLogger=WsLogger:new(modName,WsLogger.Severity.Warning)
    --self.wsLogger=wsLogger
    --self.wsLogger:print("load called")
    wsLogger:print("load called",WsLogger.Severity.Call)
    wsLogger:printVariable(modName,"ModName:",WsLogger.Severity.Debug,1)
    worker=RealTimeWorker:new(mission,modDirectory,modName,wsLogger)
    getfenv(0)["g_WsrealTimeSync"] = worker
    if mission:getIsClient() then
        wsLogger:print("is Client",WsLogger.Severity.Debug)
        addModEventListener(worker)
  end
  --worker:disable()
end
local function startMission(mission)
    wsLogger:print("start mission called", WsLogger.Severity.Call)
    worker:onStartMission(mission)
end
local function init()
    Mission00.load=Utils.prependedFunction(Mission00.load, load)
    --Mission00.onStartMission=Utils.appendedFunction(Utils.onStartMission, startMission)
    FSBaseMission.onStartMission=Utils.appendedFunction(FSBaseMission.onStartMission, startMission)
    SleepManager.getCanSleep=Utils.overwrittenFunction(SleepManager.getCanSleep, RealTimeWorker.canSleep)


end
local function save()
    worker:save()
end
local WsRTSConsoleCommands = {
    enable=function (self)
        if worker then
            worker:enable()
        end
    end,
    disable=function (self)
        if worker then
            worker:disable()
        end
    end,
    setoffset=function (self, offset)
        if offset then
            --print("Offset:"..offset)
            worker:setoffset(offset)
        else
            print("Usage: rtsOffset <Offset to Utc in hours>\nExample: rtsOffset -5")
        end
        
    end
}
init()
addConsoleCommand("rtsEnable","Enables Real Time Synchronisation","enable",WsRTSConsoleCommands)
addConsoleCommand("rtsDisable","Disables Real Time Synchronisation","disable",WsRTSConsoleCommands)
addConsoleCommand("rtsOffset","Sets the offset to UTC for Real Time Synchronisation","setoffset",WsRTSConsoleCommands)